<form [formGroup]="thirdConfigurationStepForm">
  <table
    mat-table
    [dataSource]="offersData.savings"
    class="thirdConfigurationStepForm-table"
  >
    <ng-container matColumnDef="ageBracket">
      <th mat-header-cell *matHeaderCellDef>Age Bracket</th>
      <td mat-cell *matCellDef="let element">
        <mat-form-field>
          <input
            type="number"
            matInput
            formControlName="ageBracket"
            min="18"
            max="23"
          />
        </mat-form-field>
        <span class="ageBracket-text">to 24</span>
        @if (isAgeBracketInvalid) {
        <mat-error>
          @if (ageBracket?.hasError('required')) { Required. } @else if
          (ageBracket?.hasError('min')) { Minimum acceptable age is 18. } @else
          { Maximum acceptable age is 23.}
        </mat-error>
        }
      </td>
    </ng-container>

    <ng-container matColumnDef="employee">
      <th mat-header-cell *matHeaderCellDef>Employee</th>
      <td mat-cell *matCellDef="let element">
        <mat-form-field>
          <input
            type="number"
            min="0"
            max="100000"
            matInput
            formControlName="employee"
          />
        </mat-form-field>
        @if (isEmployeeInvalid) {
        <mat-error>
          @if (employee?.hasError('required')) { Required. } @else if
          (employee?.hasError('min')) { Minimum acceptable number is 0. } @else
          { Maximum acceptable number is 100000.}
        </mat-error>
        }
      </td>
    </ng-container>

    <ng-container matColumnDef="employer">
      <th mat-header-cell *matHeaderCellDef>Employer</th>
      <td mat-cell *matCellDef="let element">
        <mat-form-field>
          <input
            type="number"
            min="0"
            max="100000"
            matInput
            formControlName="employer"
          />
        </mat-form-field>
        @if (isEmployerInvalid) {
        <mat-error>
          @if (employer?.hasError('required')) { Required. } @else if
          (employer?.hasError('min')) { Minimum acceptable number is 0. } @else
          { Maximum acceptable number is 100000.}
        </mat-error>
        }
      </td>
    </ng-container>

    <ng-container matColumnDef="employeeDeduction">
      <th mat-header-cell *matHeaderCellDef>Employee Deduction</th>
      <td mat-cell *matCellDef="let element">
        <mat-form-field>
          <input
            type="number"
            matInput
            min="0"
            max="100000"
            formControlName="employeeDeduction"
          />
        </mat-form-field>
        @if (isEmployeeDeductionInvalid) {
        <mat-error>
          @if (employeeDeduction?.hasError('required')) { Required. } @else if
          (employeeDeduction?.hasError('min')) { Minimum acceptable number is 0.
          } @else { Maximum acceptable number is 100000.}
        </mat-error>
        }
      </td>
    </ng-container>

    <ng-container matColumnDef="employeeSupplement">
      <th mat-header-cell *matHeaderCellDef>Employee Savings</th>
      <td mat-cell *matCellDef="let element">
        <mat-form-field>
          <input
            type="number"
            matInput
            min="0"
            max="100000"
            formControlName="employeeSupplement"
          />
        </mat-form-field>
        @if (isEmployeeSupplementInvalid) {
        <mat-error>
          @if (employeeSupplement?.hasError('required')) { Required. } @else if
          (employeeSupplement?.hasError('min')) { Minimum acceptable number is
          0. } @else { Maximum acceptable number is 100000.}
        </mat-error>
        }
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
  </table>
  @if (thirdConfigurationStepForm.invalid) {
  <p role="alert" class="optional-substep-alert">
    **Either provide ALL the required data or <i>Saving Contribution</i>
    configuration will NOT be taken into an account.
  </p>
  }
  <div class="button-container">
    <button
      class="medium-action-button"
      [disabled]="nextLoading"
      mat-raised-button
      matStepperPrevious
    >
      Back
      <mat-icon iconPositionStart>expand_less</mat-icon>
    </button>
    @if (nextLoading) {
    <button
      class="medium-action-button"
      [type]="thirdConfigurationStepForm.valid ? 'submit' : 'button'"
      color="primary"
      disabled
      mat-raised-button
      matStepperNext
    >
      <mat-spinner diameter="18"></mat-spinner>
    </button>
    } @else if (mode === 'preview') {
    <button
      class="medium-action-button"
      [type]="thirdConfigurationStepForm.valid ? 'submit' : 'button'"
      (click)="handleThirdSubStepNext()"
      color="primary"
      mat-raised-button
      matStepperNext
    >
      Next
      <mat-icon iconPositionEnd>expand_more</mat-icon>
    </button>
    } @else {
    <button
      class="medium-action-button"
      [type]="thirdConfigurationStepForm.valid ? 'submit' : 'button'"
      (click)="handleThirdSubStepNext()"
      color="primary"
      mat-raised-button
      matStepperNext
    >
      Complete
      <mat-icon iconPositionEnd>save</mat-icon>
    </button>
    }
  </div>
</form>
